(*
    ===========================================================================
    hCogpȂpPbg_v
    http://homepage2.nifty.com/spw/tips/PacketDump.html
    ---------------------------------------------------------------------------
    WinSock2.pas
    http://www.delphi-jedi.org/
    ---------------------------------------------------------------------------
    Delphi Programming: Get External and Internal IP Address
    http://oldlook.experts-exchange.com:8080/Programming/Programming_Languages/Delphi/Q_20733591.html
    ===========================================================================
*)


unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, WinSock2;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    Panel2: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

    procedure   StartThread();
    procedure   StopThread();

    function    AppendSysErrMsg(const S: string): string;

  public

    wsd: TWSAData;
    sock: TSocket;
    hThread: TThread;
    ThreadId: DWORD;

    function    ListAdapter(): Boolean;
    function    InitAdapter(): Boolean;
    procedure   Print(const buf: array of Byte; const len: integer);

    procedure   AddMsg(const S: string);
    procedure   AddErrMsg(const S: string);

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    dump_misc;

//  ---------------------------------------------------------------------------
//  G[bZ[W̕t
function    TMainForm.AppendSysErrMsg(const S: string): string;
begin
    Result := Format('%s * %s', [S, SysErrorMessage(GetLastError())]);
end;

//  ---------------------------------------------------------------------------
//  bZ[W\
procedure   TMainForm.AddMsg(const S: string);
begin
    Memo1.Lines.Add(S);
end;

//  ---------------------------------------------------------------------------
//  G[bZ[W\
procedure   TMainForm.AddErrMsg(const S: string);
begin
    Memo1.Lines.Add(AppendSysErrMsg(S));
end;

//  ---------------------------------------------------------------------------
//  bZ[WNA
procedure TMainForm.Button2Click(Sender: TObject);
begin
    Memo1.Clear();
end;

//  ---------------------------------------------------------------------------
//  A_v^ꗗ
function    TMainForm.ListAdapter(): Boolean;
var
    Temp: string;
    slist: LPSOCKET_ADDRESS_LIST;
    d: DWORD;
    s: TSocket;
    i, ret: integer;
begin
    ComboBox1.Clear;
    Result := false;

    //  \Pbg쐬
    s := WSASocket(AF_INET, SOCK_RAW, IPPROTO_IP, nil, 0, WSA_FLAG_OVERLAPPED);

    //  s
    if (INVALID_SOCKET = s) then
    begin
        Temp := Format('WSASocket(AF_INET,SOCK_RAW) failed', []);
        AddErrMsg(Temp);
    end
    //  
    else
    begin
        //  m
        GetMem(slist, LIST_SIZE);

        try
            //  WSAIoctls
            ret := WSAIoctl(s, SIO_ADDRESS_LIST_QUERY, nil, 0, slist, LIST_SIZE, @d, nil, nil);
            if (SOCKET_ERROR = ret) then
            begin
                Temp := Format('WSAIoctl(SIO_ADDRESS_LIST_QUERY) faild.', []);
                AddErrMsg(Temp);
            end
            //  
            else
            begin
                //  
                for i := 0 to slist.iAddressCount - 1 do
                begin
                    Temp := Format('%d. (%s)', [i, inet_ntoa((slist.Address[i].lpSockaddr).sin_addr)]);
                    ComboBox1.Items.Add(Temp);
                end;
                //  ܂ŗ
                Result := true;
            end;

        finally
            //  
            FreeMem(slist, LIST_SIZE);
            //  \Pbgj
            closesocket(s);
        end;
    end;

    if (ComboBox1.Items.Count > 0) then ComboBox1.ItemIndex := 0;
end;

//  ---------------------------------------------------------------------------
//  A_v^̏
function    TMainForm.InitAdapter(): Boolean;
var
    Temp: string;
    ret: integer;
    optval: integer;
    d: DWORD;
    slist: LPSOCKET_ADDRESS_LIST;
    addr_in: TSockAddrIn;
begin
    Result := false;

    //  SOCKET̐
    sock := WSASocket(AF_INET, SOCK_RAW, IPPROTO_IP, nil, 0, WSA_FLAG_OVERLAPPED);
    if (INVALID_SOCKET = sock) then
    begin
        Temp := Format('WSASocket(AF_INET,SOCK_RAW) failed', []);
        AddErrMsg(Temp);
    end
    else
    begin
        //  m
        GetMem(slist, LIST_SIZE);

        try
            //  A_v^̃Xg擾
            ret := WSAIoctl(sock, SIO_ADDRESS_LIST_QUERY, nil, 0, slist, LIST_SIZE, @d, nil, nil);
            if (SOCKET_ERROR = ret) then
            begin
                Temp := Format('WSAIoctl(SIO_ADDRESS_LIST_QUERY) faild.', []);
                AddErrMsg(Temp);
            end
            else
            begin
                //  SOCKET ̃f[^Zbg
                FillChar(addr_in, SizeOf(addr_in), 0);
                addr_in.sin_addr.S_addr := slist.Address[ComboBox1.ItemIndex].lpSockaddr.sin_addr.S_addr;
                addr_in.sin_family := AF_INET;
                addr_in.sin_port := htons(0);
                //  bind
                ret := bind(sock, @addr_in, SizeOf(addr_in));
                if (SOCKET_ERROR = ret) then
                begin
                    Temp := Format('bind failed', []);
                    AddErrMsg(Temp);
                end
                else
                begin
                    optval := 1;
                    ret := WSAIoctl(sock, SIO_RCVALL, @optval, sizeof(optval), nil, 0, @d, nil, nil);
                    if (SOCKET_ERROR = ret) then
                    begin
                        Temp := Format('WSAIoCtl(SIO_RCVALL) failed', []);
                        AddErrMsg(Temp);
                    end
                    else
                    begin
                        Result := true;
                    end;
                end;
            end;

        finally
            //  
            FreeMem(slist, LIST_SIZE);
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  _v
procedure   TMainForm.Print(const buf: array of Byte; const len: integer);

    //  c's isprint
    function    IsPrint(const c: Char): Boolean;
    begin
        Result := (c in [#$20..#$7E]);
    end;

var
    Tmp: string;
    i, j: integer;
    d: integer;
    c: char;
begin
    AddMsg('');

    //  
    Tmp := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now());
    AddMsg(Tmp);

    //  AhX
    Tmp := Format('PROTOCOL: %s   FROM: %d.%d.%d.%d:%d   TO: %d.%d.%d.%d:%d', [
                  Protocol[buf[9]],
                  buf[12], buf[13], buf[14], buf[15], buf[20] * 256 + buf[21],
                  buf[16], buf[17], buf[18], buf[19], buf[22] * 256 + buf[23]
                  ]);
    AddMsg(Tmp);

    Tmp := '+------+-------------------------------------------------+------------------+';
    AddMsg(Tmp);

    //  16i_v
    i := 0;
    while true do
    begin
        //  S\ or \
        if (RadioButton1.Checked) and (i > 2) then break;

        d := len - i * 16;
        if (d > 16) then d := 16;
        if (d <= 0) then break;

        //  sԍ\
        Tmp := Format('| %4.4x | ', [i]);

        //  oCi\
        for j := 0 to d - 1 do
        begin
            Tmp := Tmp + Format('%2.2x ', [buf[i * 16 + j]]);
        end;
        for j := d to 16 - 1 do Tmp := Tmp + '   ';

        Tmp := Tmp + '| ';

        //  \
        for j := 0 to d - 1 do
        begin
            c := Chr(buf[i * 16 + j]);
            if not IsPrint(c) then c := '.'; 
            Tmp := Tmp + c;
        end;
        for j := d to 16 - 1 do Tmp := Tmp + ' ';

        Tmp := Tmp + ' |';

        AddMsg(Tmp);

        if (d <> 16) then break;

        Inc(i);
    end;

    Tmp := '+------+-------------------------------------------------+------------------+';
    AddMsg(Tmp);
end;

//  ---------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    Memo1.Clear();

    //  Ver2.2 WinSock
    WSAStartup(MAKEWORD(2, 2), wsd);
    hThread := nil;
    sock := INVALID_SOCKET; 
    //A_v^̃XgR{{bNɎ擾
    ListAdapter();
end;

//  ---------------------------------------------------------------------------
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  Lv`Xbhs̏ꍇXgbv
    if (hThread <> nil) then
    begin
        StopThread();
    end;
    //  WinSock̏I
    WSACleanup();
end;

//  ---------------------------------------------------------------------------
//  Lv`Xbh
type
    TCaputureThread = class(TThread)
    private
        Msg: string;
        Buf: array[0..MAX_IP_SIZE - 1] of Byte;
        Len: Cardinal;
        procedure   DoError();
        procedure   DoPrint();
    protected
        procedure Execute; override;
    end;

//  ---------------------------------------------------------------------------
procedure   TCaputureThread.DoError();
begin
    MainForm.AddErrMsg(Msg);
end;

//  ---------------------------------------------------------------------------
procedure   TCaputureThread.DoPrint();
begin
    MainForm.Print(Buf, Len);
end;

//  ---------------------------------------------------------------------------
//  Lv`Xbh{
procedure TCaputureThread.Execute;
var
    wsb: PWSABUF;
    ret: integer;
    Flags: Cardinal;
begin
    //  m
    New(wsb);
    wsb.buf := @Buf;
    wsb.len := MAX_IP_SIZE;

    while not Terminated do
    begin
        Sleep(1);

        FillChar(Buf, SizeOf(Buf), 0);
        Flags := 0;
        //  pPbg擾
        ret := WSARecv(MainForm.sock, wsb, 1, Len, Flags, nil, nil);
        if (SOCKET_ERROR = ret) then
        begin
            Msg := Format('WSARecv failed.(socket: %d)', [MainForm.sock]);
            if not Terminated then Synchronize(DoError);
            continue;
        end;
        //  pPbg\
        if not Terminated then Synchronize(DoPrint);
    end;

    //  
    Dispose(wsb);
end;

//  ---------------------------------------------------------------------------
//  Lv`JnEIiLv`Xbh̐Ejj
procedure TMainForm.Button1Click(Sender: TObject);
begin
    //  Lv`Jn
    if (hThread = nil) then
        StartThread()

    //  Lv`I
    else
        StopThread();
        
end;

//  ---------------------------------------------------------------------------
//  Xbh̊Jn
procedure   TMainForm.StartThread();
begin
    if (InitAdapter()) then
    begin
        //  Lv`Xbh
        hThread := TCaputureThread.Create(true);
        hThread.Resume;
        Button1.Caption := 'Stop';
    end;
end;

//  ---------------------------------------------------------------------------
//  Xbh̒~
procedure   TMainForm.StopThread();
begin
    //  \Pbgf
    shutdown(sock, 2);
    closesocket(sock);
    //  Lv`Xbh̔j
    hThread.Terminate;
    hThread.Free;
    hThread := nil;
    Button1.Caption := 'Start';
end;

end.

